%================================================
% Differential Migration for Time Delay Toolbox
%================================================

echo off;
warning off;

global noaa;

global JR;
global NP;
global CD;
global AE;
global MNE;
global PRT;
global max1;
global max2;
global min1;
global min2;
global cvStore PopulationStore;
global NEStore;

PopList=[ min1 max1 1; min1 max1 1; min1 max1 1; min1 max1 1; min2 max2 1; min2 max2 1 ];
SizePL=size(PopList);
Dim=SizePL(1,1);
CR=PRT;
SS=1;

if noaa==0
    str=input('Generate new population?(1=yes/0=no) ');
    if str==1
        clear Population cv;
        newpop;
        PopulationStore=Population;
        clock
        calccv;
        clock
        cvStore=cv;
        NE=1;
    else
        Population=PopulationStore;
        NE=NEStore;
    end
else
    clear Population;
    newpop;
    PopulationStore=Population;
    NE=1;
end

if noaa==0
    if str==0
        str=input('Calculate Cost Function?(1=yes/0=no) ');
        if str==1
            clear cv;
            clock
            calccv;
            clock
            cvStore=cv;
        else
            cv=cvStore;
        end
    end
else
    clear cv;
    clock
    calccv;
    clock
    cvStore=cv;
end
mincv=min(cv);
Err=max(cv)-mincv;
fprintf('Minimum at %f    Error at %f\n',mincv,Err);
fprintf('Self organization began\n');
clock
store=0;
loop=0;
NEStore=NE;
while Err>=AE & NE<=MNE
   noaa=0;
   loop=loop+1;
   if loop==SS
      fprintf('Loop %d\nSearching clusters...\n',NE);
      loop=0;
   end;
   NofC=1;
   ps(1)=1;
   for i=1:NP
      IsFar=1;
      j=1;
      for j=1:NofC
         if ps(j) ~= i
             x=Population(ps(j),:)-Population(i,:);
             for k=1:Dim
                 x(k)=x(k)/(PopList(k,2)-PopList(k,1));
             end
             Dst=sqrt(x*x');
             if Dst<CD
                 if cv(i)<cv(ps(j))
                     ps(j)=i;
                 end
                 IsFar=0;
             end
         else
             IsFar=0;
         end
      end
      if IsFar==1
         NofC=NofC+1;
         ps(NofC)=i;
      end
   end
   fprintf('...%d cluster found. Calculating jumps...\n',NofC);
   for i=1:NP
      mincv=cv(i);
      minpop=Population(i,:);
      for j=1:NofC
         if ps(j)~=i
            direct=Population(ps(j),:)-Population(i,:);
            for k = 1:Dim
               if rand >= CR
                  direct(k)=0;
               end
            end
            k=JR(1)+rand*(JR(2)-JR(1));
            pop=Population(i,:)+direct*k;
            for l=1:Dim
               pop(l)=CheckType(pop(l),PopList(l,:));
            end
            tcv=FitFnc(pop);
            if tcv<mincv
               mincv=tcv;
               minpop=pop;
            end
         end
      end
      NewP(i,:)=minpop;
      Newcv(i)=mincv;
   end
   Population=NewP;
   cv=Newcv;
   mincv=min(cv);maxcv=max(cv);
   Err=maxcv-mincv;
   HistPop1(NE)=mincv;ClusterHist(NE)=NofC;
   NE=NE+1;
   store=store+1;
   if store==SS
      fprintf('Minimum at %f    Error at %f\n',mincv,Err);
      store=0;
   end
   PopulationStore=Population;
   cvStore=cv;
   NEStore=NE;
end
clock